// Highlevel handling of a session to a LysKOM server.
//
// $Id: session.h,v 1.9 1994/07/16 17:46:39 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef Session__
#define Session__

#include <stdlib.h>
#include <iostream.h>

#include "array.h"
#include "LyStr.h"
#include "kom-types.h"
#include "who-info.h"
#include "micro-conf.h"
#include "connection.h"
#include "mark.h"

#include "obsolete.h"		// For who_is_on_question.

#include "conference.h"
#include "person.h"
#include "maps.h"
#include "text.h"
//#include "memberships.h"   // +++NYI


// +++FIXME: Hur skall felhanteringen g} till?  Vi vill kunna f} ut
//           en felkod om n}got g}r fel.

class Session {
  public:
    Session(Connection * = NULL);
    Session(const Session &);
    ~Session();

    const Session & operator = (const Session &);

    friend ostream &operator <<(ostream &, const Session &);

    void       set_connection(Connection *);

    Conferences &  conferences();
    Persons     &  persons();
    Maps        &  maps();
    Texts       &  texts();

    Status     login(Pers_no, LyStr &, Bool invisible = FALSE);
    struct tm  get_time(); 
    Array<Who_info>     who_is_on();
    Array<Micro_conf>   lookup_name(const LyStr &pattern);
    Array<Pers_no>      regexp_lookup_persons(const LyStr &pattern);
    Array<Mark>         get_marks();

  private:
    Connection  * conn;

    Conferences * all_confs;
    Persons     * all_persons;
    Maps        * all_maps;
    Texts       * all_texts;
    
};
#endif  // Session__
