# The print procedures for nilkom.
#
# $Id: nilkom_print.tcl,v 1.8 1994/07/16 16:39:03 inge Exp $
# Copyright (C) 1994  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


set more_previous_handler {}
set moring 0
set more_prompt "**MER** (SPC, RET, s, q): "

proc print {str} {
    nilkom_print $str
    if {[nilkom_page pending]} {
	more_pause
    }
    nilkom_page sync
}

proc more_pause {} {
    global more_previous_handler
    global keyhandler
    global moring
    global more_prompt

    if {$moring == 0} {
	nilkom_page prompt "$more_prompt"
	set more_previous_handler $keyhandler
	set keyhandler more_keypress
    }
    set moring 1
}

proc more_keypress {n} {
    global keyhandler

    switch $n {
	10
	    {
		nilkom_page next
		more_maybe_continue
	    }
	32
	    {
		nilkom_page next
		more_maybe_continue
	    }
	113
	    -
	81
	    {
		nilkom_page prompt ""
		nilkom_page discard
		more_end
		reject
		switch $keyhandler {
		    commandline
			print_prompt
    		}
	    }
	115 
	    -
	83
	    {
		nilkom_page prompt ""
		nilkom_page discard
		more_end
		print "Texten kommer att lsmarkeras om du inte ger kommandot"
		puts "  lsmarkera inte"
		switch $keyhandler {
		    commandline
			print_prompt
    		}
	    }
	default
	    {
		puts -nonewline "\a"
	    }
    }
    nilkom_page sync
    flush stdout
    return 0
}

proc more_end {} {
    global more_previous_handler 
    global keyhandler
    global moring

    set moring 0
    set keyhandler $more_previous_handler
}

proc more_maybe_continue {} {
    global moring
    global more_prompt

    if {[nilkom_page pending]} {
	nilkom_page prompt "$more_prompt"
    } else {
	more_end
    }
}

# Wait until all pending output has been displayed, and return 0.
# The user can use SPC and RET to scroll forward.  If the user
# enters q or Q all pending output will be discarded and 1 will
# be returned.
# 
proc more_flush {prompt} {
    global moring
    
    if {[nilkom_page pending]} {
	while {[nilkom_page pending]} {
	    nilkom_page prompt "$prompt"
	    switch [nilkom_get_key] {
		32
		{
		    nilkom_page next
		}
		10
		{
		    nilkom_page next
		}
		113
		-
		81
		{
		    nilkom_page prompt ""
		    nilkom_page discard
		    more_end
		    return 1
		}
		default
		{
		    puts -nonewline "\a"
		}
	    }
	    nilkom_page sync
	    flush stdout
	}
	more_end
    }
    return 0
}
